libvirt/tools/virt-sanlock-cleanup.in
Daniel P. Berrange 97e4f21782 Support automatic creation of leases for disks in sanlock
The current sanlock plugin requires a central management
application to manually add <lease> elements to each guest,
to protect resources that are assigned to it (eg writable
disks). This makes the sanlock plugin useless for usage
in more ad hoc deployment environments where there is no
central authority to associate disks with leases.

This patch adds a mode where the sanlock plugin will
automatically create leases for each assigned read-write
disk, using a md5 checksum of the fully qualified disk
path. This can work pretty well if guests are using
stable disk paths for block devices eg /dev/disk/by-path/XXXX
symlinks, or if all hosts have NFS volumes mounted in
a consistent pattern.

The plugin will create one lockspace for managing disks
with filename /var/lib/libvirt/sanlock/__LIBVIRT__DISKS__.
For each VM disks, there will be another file to hold
a lease /var/lib/libvirt/sanlock/5903e5d25e087e60a20fe4566fab41fd
Each VM disk lease is usually 1 MB in size. The script
virt-sanlock-cleanup should be run periodically to remove
unused lease files from the lockspace directory.

To make use of this capability the admin will need to do
several tasks:

 - Mount an NFS volume (or other shared filesystem)
   on /var/lib/libvirt/sanlock
 - Configure 'host_id' in /etc/libvirt/qemu-sanlock.conf
   with a unique value for each host with the same NFS
   mount
 - Toggle the 'auto_disk_leases' parameter in qemu-sanlock.conf

Technically the first step can be skipped, in which case
sanlock will only protect against 2 vms on the same host
using the same disk (or the same VM being started twice
due to error by libvirt).

* src/locking/libvirt_sanlock.aug,
  src/locking/sanlock.conf,
  src/locking/test_libvirt_sanlock.aug: Add config params
  for configuring auto lease setup
* libvirt.spec.in: Add virt-sanlock-cleanup program, man
  page
* tools/virt-sanlock-cleanup.in: Script to purge unused
  disk resource lease files
2011-06-28 18:18:06 +01:00

97 lines
2.1 KiB
Bash

#!/bin/sh
# A script to cleanup resource leases auto-created by
# the libvirt lock plugin for sanlock
verbose=1
if test "x$1" = "x-q" ; then
verbose=0
fi
LOCKSPACE="__LIBVIRT__DISKS__"
LOCKDIR=`augtool print '/files@SYSCONFDIR@/libvirt/qemu-sanlock.conf/disk_lease_dir'`
if test $? != 0 || "x$LOCKDIR" = "x" ; then
LOCKDIR="@LOCALSTATEDIR@/lib/libvirt/sanlock"
fi
notify() {
test $verbose = 1 || return
if test "x$1" = "x-n"; then
shift
printf %s "$*"
else
printf %s\\n "$*"
fi
}
cd "$LOCKDIR" || exit 1
for MD5 in *
do
if test $MD5 != '*' && $MD5 != $LOCKSPACE ; then
RESOURCE="$LOCKSPACE:$MD5:$LOCKDIR/$MD5:0"
notify -n "Cleanup: $RESOURCE "
sanlock client command -r $RESOURCE -c /bin/rm -f "$LOCKDIR/$MD5" 2>/dev/null
if test $? = 0 ; then
notify "PASS"
else
notify "FAIL"
fi
fi
done
exit 0
: <<=cut
=pod
=head1 NAME
virt-sanlock-cleanup - remove stale sanlock resource lease files
=head1 SYNOPSIS
virt-sanlock-cleanup
=head1 DESCRIPTION
This tool removes any resource lease files created by the sanlock
lock manager plugin. The resource lease files only need to exist
on disks when a guest using the resource is active. This script
reclaims the disk space used by resources which are not currently
active.
=head1 EXIT STATUS
Upon successful processing of leases cleanup, the exit status
will be 0 will be set. Upon fatal error a non-zero status will
be set.
=head1 AUTHOR
Daniel Berrange
=head1 BUGS
Report any bugs discovered to the libvirt community via the
mailing list C<http://libvirt.org/contact.html> or bug tracker C<http://libvirt.org/bugs.html>.
Alternatively report bugs to your software distributor / vendor.
=head1 COPYRIGHT
Copyright (C) 2011 Red Hat, Inc.
=head1 LICENSE
virt-sanlock-cleanup is distributed under the terms of the GNU GPL v2+.
This is free software; see the source for copying conditions. There
is NO warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE
=head1 SEE ALSO
C<virsh(1)>, online instructions C<http://libvirt.org/locksanlock.html>
=cut